#!/bin/sh
##------------------------------------------------------------------------------
## local: opt\files\srv\www\admin\mynotes.cgi
## fli4l: srv/www/admin/mynotes.cgi
## DE: OPT_HTTPD Webadmin Webseite fr My Notes
## EN: OPT_HTTPD webadmin page for My Notes
##------------------------------------------------------------------------------
##
## Creation:       20.11.2008  Florian Schlgl  <Florian_Schloegl.Wolfsteam@web.de>
## Last modified:  20.11.2008  Florian Schlgl  <Florian_Schloegl.Wolfsteam@web.de>
## Version:        0.1.0-1.0.0
##
##------------------------------------------------------------------------------
## Files:   /var/run/mynotes.conf
##          MYNOTE_NOTES_PATH/mynote_*.txt
##------------------------------------------------------------------------------
. /srv/www/include/cgi-helper
. /var/run/mynotes.conf

# DE: Defaultwerte setzen
# EN: set default values
: ${FORM_action:=view}
: ${FORM_note:=1}

# HTML-Header ausgeben
show_html_header "My Notes"

case $FORM_action in
#----------------------------------------
# DE: Ein neuen Tab erzeugen
# EN: create a new tab
#----------------------------------------
    newnote)
        check_rights "mynotes" "new"
        number=`ls $MYNOTES_NOTES_PATH -1 | grep "" -c`
        number=`expr $number + 1`
        mkdir -p $MYNOTES_NOTES_PATH
        echo "New Note $number
Text of note $number" > $MYNOTES_NOTES_PATH/mynote_$number.txt
        show_info "$_header_new_note_created" "$_new_note_created<CENTER><A href=\"$myname?note=$number\">$_cmd_view</A></CENTER>"
        echo "<META http-equiv=\"refresh\" content=\"0; URL=$myname?note=$number\">"
    ;;
    
#----------------------------------------
# DE: Notiz lschen
# EN: delete note
#----------------------------------------
    $_cmd_delete_note)
        check_rights "mynotes" "delete"
        count=`ls $MYNOTES_NOTES_PATH -1 | grep "" -c`
        for idx in `seq $FORM_note $count`
        do
            idx2=`expr $idx + 1`
            cat $MYNOTES_NOTES_PATH/mynote_$idx2.txt > $MYNOTES_NOTES_PATH/mynote_$idx.txt
        done
        rm $MYNOTES_NOTES_PATH/mynote_$count.txt
        show_info "$_header_new_note_deleted" "$_new_note_deleted<CENTER><A href=\"$myname\">$_cmd_back</A></CENTER>"
        echo "<META http-equiv=\"refresh\" content=\"5; URL=$myname\">"
    ;;
    
#----------------------------------------
# DE: Notiz speichern
# EN: save note
#----------------------------------------
    $_cmd_save_note)
        check_rights "mynotes" "save"
        echo "$FORM_header
$FORM_text" > $MYNOTES_NOTES_PATH/mynote_$FORM_note.txt
        show_info "$_header_new_note_saved" "$_new_note_saved<CENTER><A href=\"$myname?note=$FORM_note\">$_cmd_back</A></CENTER>"
        echo "<META http-equiv=\"refresh\" content=\"3; URL=$myname?note=$FORM_note\">"
    ;;
    
#----------------------------------------
# DE: Notiz anzeigen
# EN: view notes
#----------------------------------------
    *)
        check_rights "mynotes" "view"
        # DE: Fr jede Notiz ein Tab erzeugen
        # EN: create a tab for each note
        for f in $MYNOTES_NOTES_PATH/mynote_*.txt
        do
            if [ ! $f = "$MYNOTES_NOTES_PATH/mynote_*.txt" ]
            then
                {
                    read headline
                } < $f
                
                if [ "$headline" = "" ]
                then
                    headline="(None)"
                fi
                number=`basename $f .txt`
                number=`echo $number | cut -b8-`
                if [ "$FORM_note" = "$number" ]
                then
                    tabs="$tabs \"$headline\" \"no\" "
                else
                    tabs="$tabs \"$headline\" \"$myname?note=$number\" "
                fi
            fi
        done
        tabs="$tabs \"$_cmd_create_new_note\" \"$myname?action=newnote\" "

        # DE: Tabs ausgeben
        # EN: Print tabs
        eval show_tab_header $tabs

        # DE: Notiz ausgeben
        # EN: print note
        {
            echo "<FORM action=\"$myname?note=$FORM_note\" method=\"post\">"
            echo "<INPUT type=\"hidden\" name=\"note\" value=\"$FORM_note\"/>"
            echo "<TABLE class=\"normtable\" style=\"width:$MYNOTES_TEXTAREA_WIDTH; height:$MYNOTES_TEXTAREA_HEIGHT\">"
            read header
            echo "<TR><TD><INPUT type=\"text\" name=\"header\" value=\"$header\" size=\"$MYNOTES_HEADER_SIZE\"/><INPUT type=\"submit\" name=\"action\" value=\"$_cmd_save_note\"/><INPUT type=\"submit\" name=\"action\" value=\"$_cmd_delete_note\"/></TD></TR>"
            echo "<TR style=\"height:100%\"><TD><textarea name=\"text\" style=\"width:100%; height:100%\">"
            while read l
            do
                echo "$l"
            done
            echo "</textarea></TD></TR>"
            echo "</TABLE></FORM>"
        } < $MYNOTES_NOTES_PATH/mynote_$FORM_note.txt
        
        show_tab_footer
    ;;
esac

#----------------------------------------
# DE: Ende des Dokuments ausgeben
# EN: print end of doc
#----------------------------------------
show_html_footer

##------------------------------------------------------------------------------
## mynotes.cgi -- EOF ---
##------------------------------------------------------------------------------